Comments in TypeScript DOCX Editor

24 Sep 20269 minutes to read

TypeScript DOCX Editor (Document Editor) allows you to add comments to documents. You can add, navigate, and remove comments in code and from the UI.

Add a new comment

Comments can be inserted into the selected text.

//Add new comment in the document.
documentEditor.editor.insertComment('Test comment');

Add a New Comment with Date, Author, and Status

Comments can be inserted into the selected text with a specified date, author, and status using insertComment.

  • TS
  • // In this example, a comment with the text "Hello world"
    // is added by the author Nancy Davolio on July 23, 2024, at 2:30 PM. 
    // The isResolved status is set to false.
    
    // Create a specific date: July 23, 2024, at 2:30:00 PM.
    // Note: July is represented by 6 (0-based index).
    let specificDate = new Date(2024, 6, 23, 14, 30, 0); 
    
    
    // Define the properties of the comment including author, date, and resolution status.
    let commentProperties: CommentProperties = { 
        author: 'Nancy Davolio',          // The author of the comment.
        dateTime: specificDate,           // The date and time when the comment is created.
        isResolved: false                 // The status of the comment; false indicates it is unresolved.
    };
    
    // Insert the comment with the specified properties into the document editor.
    documentEditor.editor.insertComment('Hello world', commentProperties);

    Add a Reply Comment with Date, Author, and Status

    Reply comments can be inserted into the parent comment with a specified date, author, and status using insertReplyComment.

  • TS
  • // In this example, a comment with the text "Hello world"
    // is added by the author Nancy Davolio on July 23, 2024, at 2:30 PM. 
    // The isResolved status is set to false.
    
    // Create a specific date: July 23, 2024, at 2:30:00 PM.
    // Note: July is represented by 6 (0-based index).
    let specificDate = new Date(2024, 6, 23, 14, 30, 0);
    
    // Define the properties of the comment including author, date, and resolution status.
    let commentProperties: CommentProperties = { 
        author: 'Nancy Davolio',          // The author of the comment.
        dateTime: specificDate,           // The date and time when the comment is created.
        isResolved: false                 // The status of the comment; false indicates it is unresolved.
    };
    
    // Insert the comment with the specified properties into the Document Editor.
    let comment: Comment = documentEditor.editor.insertComment('Hello world', commentProperties);
    // Insert a reply comment with specified properties into the Document Editor
    documentEditor.editor.insertReplyComment(comment.id, 'Hello world', commentProperties);

    Get Comments

    The DOCX Editor allows you to get the comments along with their reply and comment properties using getComments.

  • TS
  • //Get Comments in the document along with the properties author, date, status.
    let commentinfo: CommentInfo[] = container.documentEditor.getComments();

    Comment navigation

    Next and previous comments can be navigated using the below code snippet.

    //Navigate to next comment
    documentEditor.selection.navigateNextComment();
    
    //Navigate to previous comment
    documentEditor.selection.navigatePreviousComment();

    Delete comment

    Current comment can be deleted using deleteComment.

  • TS
  • //Delete the current selected comment.
    container.documentEditor.editor.deleteComment();
    
    //Get Comments in the document along with the properties author, date, status.
    let commentinfo: CommentInfo[] = container.documentEditor.getComments();
    
    //Delete the particular parent comment and all of its reply comments
    container.documentEditor.editor.deleteComment(commentinfo[0].id);
    
    //Delete the particular reply comment.
    container.documentEditor.editor.deleteComment(commentinfo[0].replies[0].id);

    Delete all comments

    All the comments in the document can be deleted using the below code snippet.

    //Delete all the comments present in the current document.
    documentEditor.editor.deleteAllComments();

    Protect the document in comments-only mode

    The DOCX Editor provides support for protecting the document with CommentsOnly protection. In this protection, the user is allowed to add or edit comments alone in the document.

    The DOCX Editor provides an option to protect and unprotect the document using enforceProtection and stopProtection API.

    The following example code illustrates how to enforce and stop protection in the Document Editor container.

    let container: DocumentEditorContainer = new DocumentEditorContainer({
      enableToolbar: true,
      height: '590px',
    });
    DocumentEditorContainer.Inject(Toolbar);
    container.serviceUrl =
      'http://localhost:5000/api/documenteditor/';
    container.appendTo('#container');
    
    //enforce protection
    container.documentEditor.editor.enforceProtection('123', 'CommentsOnly');
    
    //stop the document protection
    container.documentEditor.editor.stopProtection('123');

    Comment only protection can be enabled in the UI by using the Restrict Editing pane

    Enable comment only protection

    In the enforce Protection method, the first parameter denotes the password and the second parameter denotes the protection type. Possible values of protection type are NoProtection | ReadOnly | FormFieldsOnly | CommentsOnly. In the stop protection method, the parameter denotes the password.

    Mention Support in comments

    Mention support displays a list of items that users can select or tag from the suggested list. To use this feature, type the @ character in the comment box and select or tag the user from the suggestion list.

    The following example illustrates how to enable mention support in the DOCX Editor.

    let mentionData: any = [
        { "Name": "Mary Kate", "EmailId": "[email protected]" },
        { "Name": "Andrew James", "EmailId": "[email protected]" },
        { "Name": "Andrew Fuller", "EmailId": "[email protected]"}
    ];
    let container: DocumentEditorContainer = new DocumentEditorContainer({ enableToolbar: true,height: '590px',
    // Enable mention support in document editor
      documentEditorSettings: {
        mentionSettings: { dataSource: mentionData, fields: { text: 'Name' }},
      }
    });
    DocumentEditorContainer.Inject(Toolbar);
    container.serviceUrl = 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/';
    container.appendTo('#container');

    The Web API hosted link https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/ utilized in the DOCX Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

    Highlight comments by author

    When highlightCommentsByAuthor is enabled, each comment marker is displayed in the author’s avatar color. Selecting a comment highlights the corresponding text and comment pane border in that color. If multiple comments appear on the same line, the marker retains the first author’s avatar color.

    The following example illustrates how to enable comment highlights in the DOCX Editor

    var container = new ej.documenteditor.DocumentEditorContainer({
        enableToolbar: true,
        height: '590px',
        // Enable mention support in document editor
        documentEditorSettings: { commentSettings: { highlightCommentsByAuthor : true } }    
    });
    
    ej.documenteditor.DocumentEditorContainer.Inject(ej.documenteditor.Toolbar);
    container.serviceUrl = 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/';
    container.appendTo('#container');

    Events

    The DOCX Editor provides beforeCommentAction event, which is triggered on comment actions like post, edit, reply, resolve, and reopen. This event provides an opportunity to perform custom logic on comment actions like post, edit, reply, resolve, and reopen. The event handler receives the CommentActionEventArgs object as an argument, which allows access to information about the comment.

    To demonstrate a specific use case, let’s consider an example where we want to restrict the delete functionality based on the author’s name. The following code snippet illustrates how to allow only the author of a comment to delete:

    import { DocumentEditorContainer, Toolbar, CommentActionEventArgs } from '@syncfusion/ej2-documenteditor';
    
    // Inject require modules.
    DocumentEditorContainer.Inject(Toolbar);
    let mentionData: any = [
        { "Name": "Mary Kate", "EmailId": "[email protected]" },
        { "Name": "Andrew James", "EmailId": "[email protected]" },
        { "Name": "Andrew Fuller", "EmailId": "[email protected]"}
    ];
    let container: DocumentEditorContainer = new DocumentEditorContainer({ enableToolbar: true,height: '590px', beforeCommentAction:beforecomment,
    // Enable mention support in document editor
      documentEditorSettings: {
        mentionSettings: { dataSource: mentionData, fields: { text: 'Name' }},
      }
    });
    DocumentEditorContainer.Inject(Toolbar);
    container.serviceUrl = 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/';
    container.appendTo('#container');
    container.currentUser="Guest User";
    
    // Event get triggerd on comment actions like Post, edit, reply, resolve and reopen
    function beforecomment(args : CommentActionEventArgs){
        // Check the type and author of the comment and current user are different
        if(args.type === "Delete" && container.currentUser !== args.author){
            // Cancel the comment action
            args.cancel = true;
        }
    }

    The Web API hosted link https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/ utilized in the DOCX Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

    Online Demo

    Explore how to add, view, and manage comments in Word documents using the JavaScript DOCX Editor in this live demo here.

Comments in React DOCX Editor

24 Sep 202614 minutes to read

React DOCX Editor (Document Editor) allows you to add comments to documents. You can add, navigate and remove comments in code and from the UI.

To know more about the comments in DocumentEditor component, you can check the video below.

Add a new comment

Comments can be inserted to the selected text.

documentEditor.editor.insertComment('Test comment');

Add a New Comment with Date, Author, and Status

Comments can be inserted into the selected text with a specified date, author, and status insertComment.

// In this example, a comment with the text "Hello world"
// is added by the author Nancy Davolio on July 23, 2024, at 2:30 PM. 
// The isResolved status is set to false.

// Create a specific date: July 23, 2024, at 2:30:00 PM.
// Note: July is represented by 6 (0-based index).
let specificDate = new Date(2024, 6, 23, 14, 30, 0); 

// Define the properties of the comment including author, date, and resolution status.
let commentProperties: CommentProperties = { 
    author: 'Nancy Davolio',          // The author of the comment.
    dateTime: specificDate,           // The date and time when the comment is created.
    isResolved: false                 // The status of the comment; false indicates it is unresolved.
};

// Insert the comment with the specified properties into the document editor.
documentEditor.editor.insertComment('Hello world', commentProperties);

Add a Reply Comment with Date, Author, and Status

Reply comments can be inserted into the parent comment with a specified date, author using insertReplyComment.

// In this example, a comment with the text "Hello world"
// is added by the author Nancy Davolio on July 23, 2024, at 2:30 PM. 
// The isResolved status is set to false.

// Create a specific date: July 23, 2024, at 2:30:00 PM.
// Note: July is represented by 6 (0-based index).
let specificDate = new Date(2024, 6, 23, 14, 30, 0); 

// Define the properties of the comment including author, date, and resolution status.
let commentProperties: CommentProperties = { 
    author: 'Nancy Davolio',          // The author of the comment.
    dateTime: specificDate,           // The date and time when the comment is created.
    isResolved: false                 // The status of the comment; false indicates it is unresolved.
};

// Insert the comment with the specified properties into the Document Editor.
let comment: Comment = documentEditor.editor.insertComment('Hello world', commentProperties);
// Insert a reply comment with specified properties into the Document Editor
documentEditor.editor.insertReplyComment(comment.id, 'Hello world', commentProperties);

Get Comments

DOCX Editor allows you to get the comments along with their replies and comment properties using getComments.

//Get Comments in the document along with the properties author, date, status.
let commentinfo: CommentInfo[] = container.documentEditor.getComments();

Comment navigation

Next and previous comments can be navigated using the below code snippet.

//Navigate to next comment
documentEditor.selection.navigateNextComment();

//Navigate to previous comment
documentEditor.selection.navigatePreviousComment();

Delete comment

Current comment can be deleted using deleteComment.

//Delete the current selected comment.
container.documentEditor.editor.deleteComment();

//Get Comments in the document along with the properties author, date, status.
let commentinfo: CommentInfo[] = container.documentEditor.getComments();

//Delete the particular parent comments and all of its reply comments
container.documentEditor.editor.deleteComment(commentinfo[0].id);

//Delete the particular reply comment.
container.documentEditor.editor.deleteComment(commentinfo[0].replies[0].id);

Delete all comment

All the comments in the document can be deleted using the below code snippet.

documentEditor.editor.deleteAllComments();

Protect the document in comments only mode

DOCX Editor provides support for protecting the document with CommentsOnly protection. In this protection, users are allowed to add or edit comments alone in the document.

DOCX Editor provides an option to protect and unprotect document using enforceProtection and stopProtection API.

The following example code illustrates how to enforce and stop protection in Document Editor container.

import { createRoot } from 'react-dom/client';
import * as React from 'react';
import {
  DocumentEditorContainerComponent,
  Toolbar,
} from '@syncfusion/ej2-react-documenteditor';
DocumentEditorContainerComponent.Inject(Toolbar);
function App() {
  let container: DocumentEditorContainerComponent;
  function enforceProtection() {
    //enforce protection
    container.documentEditor.editor.enforceProtection('123', 'CommentsOnly');
  }
  function stopProtection() {
    //stop the document protection
    container.documentEditor.editor.stopProtection('123');
  }
  return (
    <div>
      <button onClick={enforceProtection}>Enforce Protection</button>
      <button onClick={stopProtection}>Stop Protection</button>
      <DocumentEditorContainerComponent
        id="container"
        ref={(scope) => {
          container = scope;
        }}
        height={'590px'}
        serviceUrl="https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/"
        enableToolbar={true}
      />
    </div>
  );
}
export default App;
createRoot(document.getElementById('sample')).render(<App />);

The Web API hosted link https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/ utilized in the DOCX Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

Comment only protection can be enabled in the UI by using Restrict Editing pane

Enable comment only protection

In the enforceProtection method, the first parameter denotes the password and the second parameter denotes the protection type. Possible values of protection type are NoProtection |ReadOnly |FormFieldsOnly |CommentsOnly. In the stopProtection method, the parameter denotes the password.

Mention support in Comments

Mention support displays a list of items that users can select or tag from the suggested list. To use this feature, type the @ character in the comment box and select or tag the user from the suggestion list.

The following example illustrates how to enable mention support in the DOCX Editor

import { createRoot } from 'react-dom/client';
import * as React from 'react';
import {
  DocumentEditorContainerComponent,
  Toolbar,
} from '@syncfusion/ej2-react-documenteditor';
DocumentEditorContainerComponent.Inject(Toolbar);
function App() {
  let container: DocumentEditorContainerComponent;
  let mentionData = [
    { Name: 'Mary Kate', EmailId: '[email protected]' },
    { Name: 'Andrew James', EmailId: '[email protected]' },
    { Name: 'Andrew Fuller', EmailId: '[email protected]' },
  ];
  let settings = {
    showRuler: true,
    mentionSettings: { dataSource: mentionData, fields: { text: 'Name' } },
  };
  return (
    <div>
      <DocumentEditorContainerComponent
        id="container"
        ref={(scope) => {
          container = scope;
        }}
        height={'590px'}
        serviceUrl="https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/"
        enableToolbar={true}
        documentEditorSettings={settings}
      />
    </div>
  );
}
export default App;
createRoot(document.getElementById('sample')).render(<App />);

The Web API hosted link https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/ utilized in the DOCX Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

Highlight comments by author

When highlightCommentsByAuthor is enabled, each comment marker is displayed in the author’s avatar color. Selecting a comment highlights the corresponding text and comment pane border in that color. If multiple comments appear on the same line, the marker retains the first author’s avatar color.

The following example illustrates how to enable comment highlights in the DOCX Editor

let settings =  { commentSettings: { highlightCommentsByAuthor : true } };
  return (
        <DocumentEditorContainerComponent 
            id="container" 
            height="590px" 
            // Use the following service URL only for demo purposes
            serviceUrl="https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/" 
            enableToolbar={true}
            documentEditorSettings={settings} 
        />
  );

Events

DocumentEditor provides the beforeCommentAction event, which is triggered on comment actions such as Post, edit, reply, resolve, and reopen. This event provides an opportunity to perform custom logic on these comment actions. The event handler receives the CommentActionEventArgs object as an argument, which allows access to information about the comment.

To demonstrate a specific use case, let’s consider an example where we want to restrict the delete functionality based on the author’s name. The following code snippet illustrates how to allow only the author of a comment to delete:

import { createRoot } from 'react-dom/client';
import * as React from 'react';
import { useEffect, useRef } from 'react';

import {
  DocumentEditorContainerComponent,
  Toolbar,
} from '@syncfusion/ej2-react-documenteditor';

DocumentEditorContainerComponent.Inject(Toolbar);
// tslint:disable:max-line-length
const Default = () => {
  useEffect(() => {}, []);
  let hostUrl: string =
    'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/';
  let container = useRef<DocumentEditorContainerComponent>(null);
  let mentionData = [
    { Name: 'Mary Kate', EmailId: '[email protected]' },
    { Name: 'Andrew James', EmailId: '[email protected]' },
    { Name: 'Andrew Fuller', EmailId: '[email protected]' },
  ];
  let settings = {
    showRuler: true,
    mentionSettings: { dataSource: mentionData, fields: { text: 'Name' } },
  };

  // Event is triggered on comment actions such as Post, edit, reply, resolve, and reopen
  function beforeComment(args: CommentActionEventArgs) {
    // Check if the type is Delete and the author of the comment differs from the current user
    if (
      args.type === 'Delete' &&
      container.current.currentUser !== args.author
    ) {
      // Cancel the comment action
      args.cancel = true;
    }
  }
  return (
    <div className="control-pane">
      <div className="control-section">
        <div id="documenteditor_titlebar" className="e-de-ctn-title"></div>
        <div id="documenteditor_container_body">
          <DocumentEditorContainerComponent
            id="container"
            ref={container}
            style=
            height={'590px'}
            serviceUrl={hostUrl}
            enableToolbar={true}
            documentEditorSettings={settings}
            beforeCommentAction={beforeComment}
            currentUser="Guest User"
            locale="en-US"
          />
        </div>
      </div>
    </div>
  );
};
export default Default;

const root = createRoot(document.getElementById('sample'));
root.render(<Default />);

The Web API hosted link https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/ utilized in the DOCX Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

Online Demo

Explore how to add, view, and manage comments in Word documents using the React DOCX Editor in this live demo here.

Comments in Vue DOCX Editor

24 Sep 202614 minutes to read

Vue DOCX Editor (Document Editor) allows you to add comments to documents. You can add, navigate and remove comments in code and from the UI.

Add a new comment

Comments can be inserted to the selected text.

this.$refs.container.ej2Instances.documentEditor.editor.insertComment('Test comment');

Add a New Comment with Date, Author, and Status

Comments can be inserted into the selected text with a specified date, author, and status insertComment.

import { CommentProperties } from '@syncfusion/ej2-documenteditor';

// In this example, a comment with the text "Hello world"
// is added by the author Nancy Davolio on July 23, 2024, at 2:30 PM. 
// The isResolved status is set to false.

// Create a specific date: July 23, 2024, at 2:30:00 PM.
// Note: July is represented by 6 (0-based index).
let specificDate = new Date(2024, 6, 23, 14, 30, 0); 

// Define the properties of the comment including author, date, and resolution status.
let commentProperties: CommentProperties = { 
    author: 'Nancy Davolio',          // The author of the comment.
    dateTime: specificDate,           // The date and time when the comment is created.
    isResolved: false                 // The status of the comment; false indicates it is unresolved.
};

// Insert the comment with the specified properties into the Document Editor.
this.$refs.container.ej2Instances.documentEditor.editor.insertComment('Hello world', commentProperties);

Add a Reply Comment with Date, Author, and Status

Reply comments can be inserted into the parent comment with a specified date, author using insertReplyComment.

// In this example, a comment with the text "Hello world"
// is added by the author Nancy Davolio on July 23, 2024, at 2:30 PM. 
// The isResolved status is set to false.

// Create a specific date: July 23, 2024, at 2:30:00 PM.
// Note: July is represented by 6 (0-based index).
let specificDate = new Date(2024, 6, 23, 14, 30, 0); 

// Define the properties of the comment including author, date, and resolution status.
let commentProperties: CommentProperties = { 
    author: 'Nancy Davolio',          // The author of the comment.
    dateTime: specificDate,           // The date and time when the comment is created.
    isResolved: false                 // The status of the comment; false indicates it is unresolved.
};

// Insert the comment with the specified properties into the Document Editor.
let comment: Comment = this.$refs.container.ej2Instances.documentEditor.editor.insertComment('Hello world', commentProperties);
// Insert a reply comment with specified properties into the Document Editor
this.$refs.container.ej2Instances.documentEditor.editor.insertReplyComment(comment.id, 'Hello world', commentProperties);

Get Comments

DOCX Editor allows you to get the comments along with its reply and comment properties using getComments.

//Get Comments in the document along with the properties author, date, status.
let commentinfo: CommentInfo[] = this.$refs.container.ej2Instances.documentEditor.getComments();

Comment navigation

Next and previous comments can be navigated using the below code snippet.

//Navigate to next comment
this.$refs.container.ej2Instances.documentEditor.selection.navigateNextComment();

//Navigate to previous comment
this.$refs.container.ej2Instances.documentEditor.selection.navigatePreviousComment();

Delete comment

The current comment can be deleted using deleteComment.

//Delete the current selected comment.
this.$refs.container.ej2Instances.documentEditor.editor.deleteComment();

//Get comments before deletion. Refer to the Get Comments section above for details.
let commentinfo: CommentInfo[] = this.$refs.container.ej2Instances.documentEditor.getComments();

//Delete the particular parent comments and all of its reply comments
this.$refs.container.ej2Instances.documentEditor.editor.deleteComment(commentinfo[0].id);

//Delete the particular reply comment.
this.$refs.container.ej2Instances.documentEditor.editor.deleteComment(commentinfo[0].replies[0].id);

Delete all comments

All the comments in the document can be deleted using the below code snippet.

this.$refs.container.ej2Instances.documentEditor.editor.deleteAllComments();

Protect the document in comments only mode

To use the DOCX Editor component and its protection APIs, follow the Getting Started documentation to set up the component, then load a document before enforcing protection.

DOCX Editor provides support for protecting the document with CommentsOnly protection. In this protection, user is allowed to add or edit comments alone in the document.

DOCX Editor provides an option to protect and unprotect document using enforceProtection and stopProtection APIs.

The following example code illustrates how to enforce and stop protection in Document Editor container.

<template>
  <div id="app">
    <ejs-documenteditorcontainer ref='container' :serviceUrl='serviceUrl' height="590px" id='container'
      :enableToolbar='true'>
    </ejs-documenteditorcontainer>
  </div>
</template>
<script setup>
import { onMounted, ref, provide } from 'vue';
import { DocumentEditorContainerComponent as EjsDocumenteditorcontainer, Toolbar } from '@syncfusion/ej2-vue-documenteditor';

const container = ref(null);
const serviceUrl = 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/';

provide('DocumentEditorContainer', [Toolbar]);

onMounted(function () {
  //enforce protection
  container.value.ej2Instances.documentEditor.editor.enforceProtection('123', 'CommentsOnly');
  //stop the document protection
  container.value.ej2Instances.documentEditor.editor.stopProtection('123');
})

</script>
<template>
  <div id="app">
    <ejs-documenteditorcontainer ref='container' :serviceUrl='serviceUrl' height="590px" id='container'
      :enableToolbar='true'>
    </ejs-documenteditorcontainer>
  </div>
</template>
<script>
import { DocumentEditorContainerComponent, Toolbar } from '@syncfusion/ej2-vue-documenteditor';

export default {
  components: {
    'ejs-documenteditorcontainer': DocumentEditorContainerComponent
  },
  data() {
    return { serviceUrl: 'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/' };
  },
  provide: {//Inject require modules.
    DocumentEditorContainer: [Toolbar]
  },
  mounted() {
    //enforce protection
    this.$refs.container.ej2Instances.documentEditor.editor.enforceProtection('123', 'CommentsOnly');
    //stop the document protection
    this.$refs.container.ej2Instances.documentEditor.editor.stopProtection('123');
  }
}
</script>

The Web API hosted link https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/ utilized in the DOCX Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

Comment only protection can be enabled in UI by using Restrict Editing pane

Enable comment only protection

Note: In enforce Protection method, first parameter denotes password and second parameter denotes protection type. Possible values of protection type are NoProtection |ReadOnly |FormFieldsOnly |CommentsOnly. In stop protection method, parameter denotes the password.

Mention support in Comments

Mention support displays a list of items that users can select or tag from the suggested list. To use this feature, type the @ character in the comment box and select or tag the user from the suggestion list.

The following example illustrates how to enable mention support in the DOCX Editor

<template>
    <div id="app">
      <ejs-documenteditorcontainer ref='documenteditor' :serviceUrl='serviceUrl' :documentEditorSettings='settings' height="590px" id='container' :enableToolbar='true'></ejs-documenteditorcontainer>
    </div>
</template>
<script>
  import { DocumentEditorContainerComponent, Toolbar } from '@syncfusion/ej2-vue-documenteditor';
  let mentionData =  [
                { "Name": "Mary Kate", "EmailId": "[email protected]" },
                { "Name": "Andrew James", "EmailId": "[email protected]" },
                { "Name": "Andrew Fuller", "EmailId": "[email protected]"}
            ];
  export default {
    data() {
      return { serviceUrl:'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/',
      settings: { mentionSettings: { dataSource: mentionData, fields: { text: 'Name' }} }},
    },
    provide: {
      //Inject require modules.
      DocumentEditorContainer: [Toolbar]
    }
  }
</script>

The Web API hosted link https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/ utilized in the DOCX Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

Highlight comments by author

When highlightCommentsByAuthor is enabled, each comment marker is displayed in the author’s avatar color. Selecting a comment highlights the corresponding text and comment pane border in that color. If multiple comments appear on the same line, the marker retains the first author’s avatar color.

The following example illustrates how to enable comment highlights in the DOCX Editor

<template>
    <div id="app">
      <ejs-documenteditorcontainer ref='documenteditor' :serviceUrl='serviceUrl' :documentEditorSettings='settings' height="590px" id='container' :enableToolbar='true'></ejs-documenteditorcontainer>
    </div>
</template>
<script>
  import { DocumentEditorContainerComponent, Toolbar } from '@syncfusion/ej2-vue-documenteditor';
  export default {
    data() {
      return {
      serviceUrl:'https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/',
      settings: { commentSettings: { highlightCommentsByAuthor : true } }
      },
    },
    provide: {
      //Inject require modules.
      DocumentEditorContainer: [Toolbar]
    }
  }
</script>

Events

DocumentEditor provides beforeCommentAction event, which is triggered on comment actions like Post, edit, reply, resolve and reopen. This event provides an opportunity to perform custom logic on comment actions like Post, edit, reply, resolve and reopen. The event handler receives the CommentActionEventArgs object as an argument, which allows access to information about the comment.

To demonstrate a specific use case, let’s consider an example where we want to restrict the delete functionality based on the author’s name. The following code snippet illustrates how to allow only the author of a comment to delete:

<template>
  <div id="app">
    <ejs-documenteditorcontainer ref="container" height="590px" :toolbarItems='items' :documentEditorSettings="settings" :beforeCommentAction="beforeComment"
      :enableToolbar='true' :currentUser="'Guest User'" > </ejs-documenteditorcontainer>
  </div>
</template>

<script setup>
import { DocumentEditorContainerComponent as EjsDocumenteditorcontainer, Toolbar } from '@syncfusion/ej2-vue-documenteditor';
import { provide, ref } from 'vue';

const container = ref(null);
let mentionData =  [
                { "Name": "Mary Kate", "EmailId": "[email protected]" },
                { "Name": "Andrew James", "EmailId": "[email protected]" },
                { "Name": "Andrew Fuller", "EmailId": "[email protected]"}
            ];
provide('DocumentEditorContainer', [Toolbar]);
const settings= { mentionSettings: { dataSource: mentionData, fields: { text: 'Name' }} };
const beforeComment = function (args) {
  if(args.type === "Delete" && container.value.ej2Instances.currentUser !== args.author){
    args.cancel = true;
  }
}
</script>

<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-lists/styles/material.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/material.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/material.css';
@import "../node_modules/@syncfusion/ej2-documenteditor/styles/material.css";
</style>
<template>
  <div id="app">
    <ejs-documenteditorcontainer ref="container" height="590px" :beforeCommentAction="beforeComment"
      :enableToolbar='true' :documentEditorSettings="settings" :currentUser="'Guest User'" ></ejs-documenteditorcontainer>
  </div>
</template>

<script>
import { DocumentEditorContainerComponent, Toolbar } from '@syncfusion/ej2-vue-documenteditor';
let mentionData =  [
                { "Name": "Mary Kate", "EmailId": "[email protected]" },
                { "Name": "Andrew James", "EmailId": "[email protected]" },
                { "Name": "Andrew Fuller", "EmailId": "[email protected]"}
            ];
export default {
  components: {
    'ejs-documenteditorcontainer': DocumentEditorContainerComponent
  },
  data() {
    return {
      settings: { mentionSettings: { dataSource: mentionData, fields: { text: 'Name' }} }
    }
  },
  provide: {
    DocumentEditorContainer: [Toolbar]
  },
  methods: {
    beforeComment: function (args) {
      if(args.type === "Delete" && this.$refs.container.currentUser !== args.author){
        args.cancel=true;
      }
    }
  }
}
</script>

<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-lists/styles/material.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/material.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/material.css';
@import "../node_modules/@syncfusion/ej2-documenteditor/styles/material.css";
</style>

Online Demo

Explore how to add, view, and manage comments in Word documents using the Vue DOCX Editor in this live demo here.

Comments in Angular DOCX Editor

24 Sep 202612 minutes to read

Angular DOCX Editor allows you to add comments to documents. You can add, navigate and remove comments in code and from the UI.

Add a new comment

Comments can be inserted to the selected text.

this.documentEditor.editor.insertComment('Test comment');

Add a New Comment with Date, Author, and Status

Comments can be inserted into the selected text with a specified date, author, and status insertComment.

// In this example, a comment with the text "Hello world"
// is added by the author Nancy Davolio on July 23, 2024, at 2:30 PM. 
// The isResolved status is set to false.

// Create a specific date: July 23, 2024, at 2:30:00 PM.
// Note: July is represented by 6 (0-based index).
let specificDate = new Date(2024, 6, 23, 14, 30, 0); 

// Define the properties of the comment including author, date, and resolution status.
let commentProperties: CommentProperties = { 
    author: 'Nancy Davolio',          // The author of the comment.
    dateTime: specificDate,           // The date and time when the comment is created.
    isResolved: false                 // The status of the comment; false indicates it is unresolved.
};

// Insert the comment with the specified properties into the document editor.
this.documentEditor.editor.insertComment('Hello world', commentProperties);

Add a Reply Comment with Date, Author, and Status

Reply comments can be inserted into the parent comment with a specified date, author using insertReplyComment.

// In this example, a comment with the text "Hello world"
// is added by the author Nancy Davolio on July 23, 2024, at 2:30 PM. 
// The isResolved status is set to false.

// Create a specific date: July 23, 2024, at 2:30:00 PM.
// Note: July is represented by 6 (0-based index).
let specificDate = new Date(2024, 6, 23, 14, 30, 0);

// Define the properties of the comment including author, date, and resolution status.
let commentProperties: CommentProperties = { 
    author: 'Nancy Davolio',          // The author of the comment.
    dateTime: specificDate,           // The date and time when the comment is created.
    isResolved: false                 // The status of the comment; false indicates it is unresolved.
};

// Insert the comment with the specified properties into the Document Editor.
let comment: Comment = this.documentEditor.editor.insertComment('Hello world', commentProperties);
// Insert a reply comment with specified properties into the Document Editor
this.documentEditor.editor.insertReplyComment(comment.id, 'Hello world', commentProperties);

Get Comments

DOCX Editor allows you to get the comments along with their replies and comment properties using getComments.

//Get Comments in the document along with the properties author, date, status.
let commentinfo: CommentInfo[] = this.container.documentEditor.getComments();

Comment navigation

Next and previous comments can be navigated using the below code snippet.

//Navigate to next comment
this.documentEditor.selection.navigateNextComment();

//Navigate to previous comment
this.documentEditor.selection.navigatePreviousComment();

Delete comment

Current comment can be deleted using deleteComment.

//Delete the current selected comment.
this.container.documentEditor.editor.deleteComment();

//Get Comments in the document along with the properties author, date, status.
let commentinfo: CommentInfo[] = this.container.documentEditor.getComments();

//Delete the particular parent comments and all of its reply comments
this.container.documentEditor.editor.deleteComment(commentinfo[0].id);

//Delete the particular reply comment.
this.container.documentEditor.editor.deleteComment(commentinfo[0].replies[0].id);

Delete all comment

All the comments in the document can be deleted using the below code snippet.

this.documentEditor.editor.deleteAllComments();

Protect the document in comments only mode

DOCX Editor provides support for protecting the document with CommentsOnly protection. In this protection, users are allowed to add or edit comments alone in the document.

DOCX Editor provides an option to protect and unprotect document using enforceProtection and stopProtection API.

The following example code illustrates how to enforce and stop protection in Document Editor container.

import { Component, OnInit, ViewChild } from '@angular/core';
import {
  ToolbarService,
  DocumentEditorContainerComponent,
} from '@syncfusion/ej2-angular-documenteditor';
import {
  DocumentEditorContainerModule,
} from '@syncfusion/ej2-angular-documenteditor';

@Component({
  selector: 'app-container',
  standalone: true,
  imports: [DocumentEditorContainerModule],
  providers: [ToolbarService],
  template: `<div><button ejs-button (click)="protectDocument()" >Protect</button>
  <button ejs-button (click)="unProtectDocument()" >Unprotect</button>
    <ejs-documenteditorcontainer #documenteditor_default 
      serviceUrl="https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/" 
      height="600px" 
      style="display:block" 
      [enableToolbar]="true">
    </ejs-documenteditorcontainer>
</div>
  `,
})
export class AppComponent implements OnInit {
  @ViewChild('documenteditor_default')
  public container?: DocumentEditorContainerComponent;

  ngOnInit(): void {}
  public protectDocument(): void {
    //enforce protection
    this.container?.documentEditor.editor.enforceProtection(
      '123',
      'CommentsOnly'
    );
  }

  public unProtectDocument(): void {
    //stop the document protection
    this.container?.documentEditor.editor.stopProtection('123');
  }
}

The Web API hosted link https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/ utilized in the DOCX Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

Comment only protection can be enabled in the UI by using Restrict Editing pane

Enable comment only protection

In the enforceProtection method, the first parameter denotes the password and the second parameter denotes the protection type. Possible values of protection type are NoProtection |ReadOnly |FormFieldsOnly |CommentsOnly. In the stopProtection method, the parameter denotes the password.

Mention support in Comments

Mention support displays a list of items that users can select or tag from the suggested list. To use this feature, type the @ character in the comment box and select or tag the user from the suggestion list.

The following example illustrates how to enable mention support in the DOCX Editor

import { Component, OnInit } from '@angular/core';
import { ToolbarService , DocumentEditorSettingsModel } from '@syncfusion/ej2-angular-documenteditor';
@Component({
      selector: 'app-root',
      // specifies the template string for the DocumentEditorContainer component
      template: `<ejs-documenteditorcontainer serviceUrl="https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/" height="600px" style="display:block" [documentEditorSettings]= "settings" [enableToolbar]=true> </ejs-documenteditorcontainer>`,
      providers: [ToolbarService]
})
export class AppComponent implements OnInit {
    public mentionData: any = [
        { "Name": "Mary Kate", "EmailId": "[email protected]" },
        { "Name": "Andrew James", "EmailId": "[email protected]" },
        { "Name": "Andrew Fuller", "EmailId": "[email protected]"}
    ];
    public settings: DocumentEditorSettingsModel = { mentionSettings : { dataSource: this.mentionData, fields: { text: 'Name' }}  };
    ngOnInit(): void {
    }
}

The Web API hosted link https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/ utilized in the DOCX Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

Highlight comments by author

When highlightCommentsByAuthor is enabled, each comment marker is displayed in the author’s avatar color. Selecting a comment highlights the corresponding text and comment pane border in that color. If multiple comments appear on the same line, the marker retains the first author’s avatar color.

The following example illustrates how to enable comment highlights in the DOCX Editor

import { Component, OnInit } from '@angular/core';
import { ToolbarService , DocumentEditorSettingsModel } from '@syncfusion/ej2-angular-documenteditor';
@Component({
      selector: 'app-root',
      // specifies the template string for the DocumentEditorContainer component
      template: `<ejs-documenteditorcontainer serviceUrl="https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/" height="600px" style="display:block" [documentEditorSettings]= "settings" [enableToolbar]=true> </ejs-documenteditorcontainer>`,
      providers: [ToolbarService]
})
export class AppComponent implements OnInit {
    
    public settings: DocumentEditorSettingsModel = { commentSettings: { highlightCommentsByAuthor : true } };
    ngOnInit(): void {
    }
}

Events

DocumentEditor provides the beforeCommentAction event, which is triggered on comment actions such as Post, edit, reply, resolve, and reopen. This event provides an opportunity to perform custom logic on these comment actions. The event handler receives the CommentActionEventArgs object as an argument, which allows access to information about the comment.

To demonstrate a specific use case, let’s consider an example where we want to restrict the delete functionality based on the author’s name. The following code snippet illustrates how to allow only the author of a comment to delete:

import { Component, OnInit, ViewChild} from '@angular/core';
import { ToolbarService , DocumentEditorSettingsModel, DocumentEditorContainerModule, CommentActionEventArgs, DocumentEditorContainerComponent, beforeCommentActionEvent } from '@syncfusion/ej2-angular-documenteditor';
@Component({
  imports: [
    DocumentEditorContainerModule
  ],
  standalone: true,
  selector: 'app-root',
  // specifies the template string for the DocumentEditorContainer component
  template: `<ejs-documenteditorcontainer serviceUrl="https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/" height="600px" style="display:block" #documenteditor_default [documentEditorSettings]= "settings" (beforeCommentAction)="beforeComment($event)" [enableToolbar]=true> </ejs-documenteditorcontainer>`,
  providers: [ToolbarService]
})
export class AppComponent implements OnInit {
  @ViewChild('documenteditor_default', { static: true }) 
  public container!: DocumentEditorContainerComponent;
  public mentionData: any = [
    { "Name": "Mary Kate", "EmailId": "[email protected]" },
    { "Name": "Andrew James", "EmailId": "[email protected]" },
    { "Name": "Andrew Fuller", "EmailId": "[email protected]" }
  ];
  public settings: DocumentEditorSettingsModel = { mentionSettings: { dataSource: this.mentionData, fields: { text: 'Name' } } };
  ngOnInit(): void {
    this.container.currentUser="Guest User";
  }
  // Event get triggerd on comment actions like Post, edit, reply, resolve and reopen
  public beforeComment(args: CommentActionEventArgs) {
    // Check the type and author of the comment and current user are different
    if (args.type === "Delete" && this.container.currentUser !== args.author) {
      // Cancel the comment action
      args.cancel = true;
    }
  }
}

The Web API hosted link https://document.syncfusion.com/web-services/docx-editor/api/documenteditor/ utilized in the DOCX Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

Online Demo

Explore how to add, view, and manage comments in Word documents using the Angular DOCX Editor in this live demo here.